/**
 * Created by user on 23.05.2017.
 */
jQuery(function ($) {
    var progress_url;
    var process_id;
    var oldGeneration = true;

    window.Base64 = {
        // private property
        _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
        // public method for encoding
        encode: function (input) {
            var output = "";
            var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
            var i = 0;
            input = window.Base64._utf8_encode(input);
            while (i < input.length) {
                chr1 = input.charCodeAt(i++);
                chr2 = input.charCodeAt(i++);
                chr3 = input.charCodeAt(i++);

                enc1 = chr1 >> 2;
                enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                enc4 = chr3 & 63;

                if (isNaN(chr2)) {
                    enc3 = enc4 = 64;
                } else if (isNaN(chr3)) {
                    enc4 = 64;
                }

                output = output +
                        this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                        this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

            }

            return output;
        },
        // public method for decoding
        decode: function (input) {
            var output = "";
            var chr1, chr2, chr3;
            var enc1, enc2, enc3, enc4;
            var i = 0;

            input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

            while (i < input.length) {

                enc1 = this._keyStr.indexOf(input.charAt(i++));
                enc2 = this._keyStr.indexOf(input.charAt(i++));
                enc3 = this._keyStr.indexOf(input.charAt(i++));
                enc4 = this._keyStr.indexOf(input.charAt(i++));

                chr1 = (enc1 << 2) | (enc2 >> 4);
                chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                chr3 = ((enc3 & 3) << 6) | enc4;

                output = output + String.fromCharCode(chr1);

                if (enc3 !== 64) {
                    output = output + String.fromCharCode(chr2);
                }
                if (enc4 !== 64) {
                    output = output + String.fromCharCode(chr3);
                }
            }
            output = Base64._utf8_decode(output);
            return output;
        },
        // private method for UTF-8 encoding
        _utf8_encode: function (string) {
            string = string.replace(/\r\n/g, "\n");
            var utftext = "";
            for (var n = 0; n < string.length; n++) {
                var c = string.charCodeAt(n);
                if (c < 128) {
                    utftext += String.fromCharCode(c);
                } else if ((c > 127) && (c < 2048)) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                } else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
            }
            return utftext;
        },
        // private method for UTF-8 decoding
        _utf8_decode: function (utftext) {
            var string = '', i = 0, c = 0, c1 = 0, c2 = 0;
            while (i < utftext.length) {
                c = utftext.charCodeAt(i);
                if (c < 128) {
                    string += String.fromCharCode(c);
                    i++;
                } else if ((c > 191) && (c < 224)) {
                    c2 = utftext.charCodeAt(i + 1);
                    string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                    i += 2;
                } else {
                    c2 = utftext.charCodeAt(i + 1);
                    c1 = utftext.charCodeAt(i + 2);
                    string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c1 & 63));
                    i += 3;
                }
            }
            return string;
        }
    };


    var registerHelpersHandlebars = {
        init: function () {

            Handlebars.registerHelper('ifCond', function (v1, operator, v2, options) {

                switch (operator) {
                    case '==':
                        return (v1 == v2) ? options.fn(this) : options.inverse(this);
                    case '===':
                        return (v1 === v2) ? options.fn(this) : options.inverse(this);
                    case '!=':
                        return (v1 != v2) ? options.fn(this) : options.inverse(this);
                    case '!==':
                        return (v1 !== v2) ? options.fn(this) : options.inverse(this);
                    case '<':
                        return (v1 < v2) ? options.fn(this) : options.inverse(this);
                    case '<=':
                        return (v1 <= v2) ? options.fn(this) : options.inverse(this);
                    case '>':
                        return (v1 > v2) ? options.fn(this) : options.inverse(this);
                    case '>=':
                        return (v1 >= v2) ? options.fn(this) : options.inverse(this);
                    case '&&':
                        return (v1 && v2) ? options.fn(this) : options.inverse(this);
                    case '||':
                        return (v1 || v2) ? options.fn(this) : options.inverse(this);
                    default:
                        return options.inverse(this);
                }
            });

            Handlebars.registerHelper('checkedIf', function (condition) {
                return condition === '1' || condition === 1 || condition === true ? 'checked' : '';
            });

            Handlebars.registerHelper('ifIn', function (elem, list, options) {

                if (typeof list === 'object') {
                    list = Object.values(list);
                }
                return list.includes(elem) ? options.fn(this) : options.inverse(this);
            });

            Handlebars.registerHelper("math", function (lvalue, operator, rvalue, options) {
                lvalue = parseFloat(lvalue);
                rvalue = parseFloat(rvalue);

                return {
                    "+": lvalue + rvalue,
                    "-": lvalue - rvalue,
                    "*": lvalue * rvalue,
                    "/": lvalue / rvalue
                }[operator]
            });
        }
    };

    registerHelpersHandlebars.init();

    window.Notify = function (text, callback, close_callback, style) {
        var time = '10000';
        var $container = $('#ads-notify');
        var icon = '<i class="fa fa-info-circle"></i>';

        if (typeof style === 'undefined') {
            style = 'warning';
        }

        var html = $('<div class="alert alert-' + style + '  hide">' + icon + " " + text + '</div>');
        $('<a>', {
            text: '×',
            class: 'notify-close',
            href: '#',
            click: function (e) {
                e.preventDefault();
                close_callback && close_callback();
                remove_notice()
            }
        }).prependTo(html);
        $container.prepend(html);
        html.removeClass('hide').hide().fadeIn('slow');

        function remove_notice() {
            html.stop().fadeOut('slow').remove();
        }

        var timer = setInterval(remove_notice, time);
        $(html).hover(function () {
            clearInterval(timer);
        }, function () {
            timer = setInterval(remove_notice, time);
        });

        html.on('click', function () {
            clearInterval(timer);
            callback && callback();
            remove_notice();
        });
    };

    window.ADS = {
        tryJSON: function (data) {
            try {
                var response = $.parseJSON(data);
            } catch (e) {
                console.log(data);
                return false;
            }
            return response;
        },
        b64EncodeUnicode: function (str) {
            return btoa(
                encodeURIComponent(str).replace(/%([0-9A-F]{2})/g, function (match, p1) {
                    return String.fromCharCode('0x' + p1);
                })
            );
        },
        cdata: function (str) {

            str = str.replace('/*<![CDATA[*/', '');
            str = str.replace('/*]]>*/', '');

            return str;
        },
        objTotmpl: function (tmpl, data) {
            if (typeof Handlebars === 'undefined') {
                console.log('Handlebars not registry');
                return false
            }
            var template = Handlebars.compile(tmpl);
            return template(data);
        },
        serialize: function ($el) {
            var serialized = $el.serialize();
            if (!serialized)
                serialized = $el.find('input[name],select[name],textarea[name]').serialize();
            return serialized;
        },
        notify: function (message, type) {
            window.Notify(message, null, null, type);
        },
        createPagination: function (obj, total, current, perPage) {
            perPage = typeof perPage !== 'undefined' ? perPage : 10;
            var $obj = $(obj).find('.pagination-menu');
            $obj.pagination({
                items: parseInt(total),
                itemsOnPage: parseInt(perPage),
                currentPage: parseInt(current),
                cssStyle: "light-theme",
                prevText: '<span class="fa fa-angle-left"></span>',
                nextText: '<span class="fa fa-angle-right"></span>',
                onPageClick: function (pageNumber) {
                    $.event.trigger({
                        type: "pagination:click",
                        obj: obj,
                        page: pageNumber
                    });

                    $(obj).trigger({
                        type : "pagination:click",
                        obj  : obj,
                        page : pageNumber
                    });
                }
            });
        },
        switchery: function (el) {
            var elems = el.find('.switchery');
            for (var i = 0; i < elems.length; i++) {
                var switchery = new Switchery(elems[ i ]);
            }

            /*el.find('.bootstrap-select').each(function (index, value) {
                if (typeof $(value).data('value') !== 'undefined') {
                    $(value).val($(value).data('value'));
                    $(value).selectpicker($(value).data('value'));
                }

                if ($(value).find('option').length > 20) {
                    $(value).data('live-search', 'true');
                }
                $(value).selectpicker('refresh');
            });*/

            el.find('.uniform-checkbox, .uniform-radio').uniform();
            el.find('.multiselect-full-featured').multiselect({
                includeSelectAllOption: true,
                enableFiltering: true,
                templates: {
                    filter: '<li class="multiselect-item multiselect-filter"><i class="fa fa-search"></i> <input class="form-control" type="text"></li>'
                },
                onSelectAll: function () {
                    $.uniform.update();
                },
                onDeselectAll: function () {
                    $.uniform.update();
                }
            }).parent().find('.multiselect-container input[type="checkbox"]').uniform();

            this.colorpicker(el);
            this.cropper(el);
            this.addMedia(el);
            //this.textRange(el);
            this.datetimeRange(el);
            //this.productButton(el);
        },
        datetimeRange: function($el) {
            var $dateTime = $el.find('.datetime');
            if ($dateTime.length == 0) {
                return false;
            }
            var that = this;
            that.el = $el;
            var $dateTimeStart = $el.find('.dateTimeStart');
            var $dateTimeEnd = $el.find('.dateTimeEnd');
            var startMoment = moment($dateTimeStart.val(), 'YYYY-MM-DD h:mm');
            var endMoment = moment($dateTimeEnd.val(), 'YYYY-MM-DD h:mm');

            $dateTime.daterangepicker({
                startDate: startMoment,
                endDate: endMoment,
                //maxDate: endMoment.add(29, 'days'),
                //dateLimit: {days: 60},
                opens: 'right',
                applyClass: 'btn-small bg-slate',
                cancelClass: 'btn-small btn-default',
                timePicker: true,
                timePicker24Hour: true
            }, function(start, end) {
                $dateTime.find('span').html(start.format('MMMM D, YYYY') + ' &nbsp; - &nbsp; ' + end.format('MMMM D, YYYY'));
                $($dateTime.data('ads_from')).val(start.format('YYYY-MM-DD H:m'));
                $($dateTime.data('ads_to')).val(end.format('YYYY-MM-DD H:m'));
                $dateTimeStart.val(start.format('YYYY-MM-DD H:m'));
                $dateTimeEnd.val(end.format('YYYY-MM-DD H:m'));

                $.event.trigger({
                    type: "datepicker:update",
                    from: $($dateTime.data('ads_from')).val(),
                    to: $($dateTime.data('ads_to')).val()
                });
            });

            $dateTime.find('span').html(
                startMoment.format('MMMM D, YYYY') + ' &nbsp; - &nbsp; ' + endMoment.format('MMMM D, YYYY')
            );
        },
        colorpicker: function ($el) {
            if (typeof $.fn.spectrum == 'undefined') {
                return;
            }

            $el.find(".colorpicker").spectrum({
                preferredFormat: "rgb",
                showInitial: true,
                showInput: true,
                showAlpha: true,
                allowEmpty: true
            });
        },
        initCrop: function (e) {
            if (typeof $.fn.cropper == 'undefined') {
                return;
            }

            var uploadedImageType = '';
            var height = parseInt($(e).data('height'));
            var width = parseInt($(e).data('width'));
            var options = {
                aspectRatio: width / height,
                dragMode: 'move',
                cropBoxResizable: false,
                zoomable: false,
                //scalable: false,
                data: {
                    x: 0,
                    y: 0,
                    height: height,
                    width: width
                }
            };

            // Import image
            var $inputFileUrl = $(e).find('.file_url');
            var $image = $(e).find(".cropper");
            var $self = $(e);

            $image.cropper(options);
            $inputFileUrl.change(function () {
                if (!$image.data('cropper')) {
                    return;
                }
                $image.cropper('destroy').attr('src', $(this).val());//.cropper( options );
            });
            $image.cropper("setDragMode", "move");
            $(e).find('.crop_file').prop('disabled', false).show();
            $(e).find('.crop_file').on('click', function () {
                var _this = $(this);
                var data = _this.data();
                var result;
                _this.prop('disabled', true);

                if ($image.data('cropper')) {
                    data = $.extend({}, data); // Clone a new one
                    if (uploadedImageType === 'image/jpeg') {
                        if (!data.option) {
                            data.option = {};
                        }
                        data.option.fillColor = '#fff';
                    }

                    result = $image.cropper('getCroppedCanvas', data.option);
                    if (result) {
                        var form_Data = new FormData();
                        form_Data.append('action', 'ads_Media');
                        form_Data.append('ads_action', 'save_image64');
                        form_Data.append('file64', result.toDataURL(uploadedImageType));
                        form_Data.append('src', $self.find('.file_url').val());
                        form_Data.append('crop_name', $self.find('.file_url').data('crop_name'));

                        $.ajax({
                            url: ajaxurl,
                            dataType: 'json',
                            data: form_Data,
                            contentType: false,
                            processData: false,
                            type: "POST",
                            success: function (attachment) {
                                $self.find('.preview-upload').attr('src', attachment.url).parent().show();
                                $self.find('.file_url').val(attachment.url).trigger("change");
                                _this.hide();
                            }
                        });
                    }
                }
                return false;
            });
        },
        cropper: function ($el) {
            /*
             var _this = this;
             $el.find( '.uploadImg-box' ).each( function(i,e){
             _this.initCrop(e)
             }	);
             */

        },
        addMedia: function ($el) {
            var _this = this;
            $el.find('.upload_file').click(function (e) {
                e.preventDefault();
                var button = $(this);
                var custom_uploader = wp.media({
                    multiple: false
                }).on('select', function () {
                    var attachment = custom_uploader.state().get('selection').first().toJSON();
                    $(button).closest('.uploadImg-box').find('.preview-upload')
                        .attr('src', attachment.url)
                        .parent()
                        .show();
                    $(button).closest('.uploadImg-box').find('.file_url').val(attachment.url).trigger("change");
                    _this.initCrop($(button).closest('.uploadImg-box'));
                }).open();

                return false;
            });

            $el.find('.remove_file').click(function () {
                var r = true;//confirm("Уверены?");
                if (r == true) {
                    $(this).closest('.uploadImg-box').find('.preview-upload').attr('src', '').parent().hide();
                    $(this).closest('.uploadImg-box').find('.crop_file').hide();
                    $(this).closest('.uploadImg-box').find('.file_url').val('').trigger("change");
                    $(this).closest('.uploadImg-box').find('.file_url').parent().removeClass('active');
                }
                return false;
            });
        },
        progress: function ($el, total, current) {
            total = parseInt(total);
            current = parseInt(current);

            var width = total > 0 ? current * 100 / total : 0,
                    label = width.toFixed();

            $el.find('.progress-bar').css('width', width + '%');
            $el.find('.progress-percent').text(label);
        },
        mainRequest: function ($el, page) {
            var $this = this;
            var th = $el,
                    tmpl = $(th.data('ads_template')).html(),
                    action = th.data('addon_action'),
                    target = $(th.data('ads_target')),
                    data = {},
                    fields = $el.find('.ads-field');

            $this.filter = {
                category    : '',
                currency    : '',
                woocommerce : ''
            };

            if (fields.length > 0) {
                data = fields.serialize();
            } else {
                if (typeof page == 'undefined') {
                    page = 1;
                }
                data = 'page = ' + page;
            }

            $.ajax({
                url: ajaxurl,
                data: {
                    action: 'googlecatalog_ajax',
                    ads_action: action,
                    args: data
                },
                type: "POST",
                dataType: 'json',
                success: function (response) {
                    if (response) {
                        if (response.hasOwnProperty('pid')) {
                            process_id = response.pid;
                        }
                        progress_url = ajaxurl;
                        if (response.hasOwnProperty('progress_url')) {
                            progress_url = response.progress_url;
                            oldGeneration = false
                        }
                        if (response.hasOwnProperty('error')) {
                            $this.notify(response.error, 'danger');
                        } else {
                            target.html($this.objTotmpl(tmpl, response));
                            setTimeout($this.switchery(target), 300);
                            $this.createPagination(target, response.totalPage, response.page, response.limit);
                            $this.initSelect(target);
                            $this.filter.category = response['category_select'];
                            $this.filter.currency = response['currency_select'];
                            $this.filter.woocommerce = response['woocommerce'];
                            if (!oldGeneration) {
                                $this.initProgressCheck();
                            }
                            $(target).trigger({
                                type : "page:load",
                                obj  : target,
                                response: response
                            });
                        }
                    }
                }
            });
        },
        mainHandlers: function () {
            var $this = this;

            $.fn.selectpicker.defaults = {
                iconBase: '',
                tickIcon: 'fa'
            };

            $('[data-addon_action]').each(function () {
                $this.mainRequest($(this));
            });

            $this.categoryChange();
            $this.currencyChange();

            $(document).on('click', '.btn-generate-csv', function(e) {
                e.preventDefault();
                e.stopPropagation();
                var that = $(this);
                var params = {
                    currency    : $this.filter.currency,
                    woocommerce : $this.filter.woocommerce
                };
                $(this).addClass('animate-spinner').prop('disabled', true);
                $('.csv_generator .progress-bar').css('width', '0%');
                $('.csv_generator .progress-percent').html(0);
                $this.stopProgress = false;
                if (oldGeneration) {
                    $this.disableInterface();
                    $this.initXmlGeneration(1);
                } else {
                    $.ajax({
                        url: progress_url,
                        data: {
                            action: 'init_process',
                            args: $.param(params),
                            categories: $this.filter.category
                        },
                        type: 'POST',
                        dataType: 'json',
                        success: function(response) {
                            that.removeClass('animate-spinner').prop('disabled', false);
                            if (response.result == false) {
                                $this.notify(response.message, 'danger');
                            } else {
                                $this.disableInterface();
                                $this.notify(response.message, 'success');
                                $this.initProgressCheck();
                            }
                            console.log(response)
                        }
                    });
                }
            });

            $(document).on('click', '.btn-cancel-generate-csv', function(e) {
                e.preventDefault();
                e.stopPropagation();
                var params = {
                    process_id: process_id
                };

                if (oldGeneration) {
                    $this.enableInterface();
                } else {
                    $.ajax({
                        url: ajaxurl,
                        data: {
                            action: 'googlecatalog_ajax',
                            ads_action: 'cancel_action',
                            args: $.param(params)
                        },
                        type: 'POST',
                        dataType: 'json',
                        success: function(response) {
                            if (response.result == true) {
                                $this.enableInterface();
                                $('.csv_generator .progress-bar').css('width', 0 + '%');
                                $('.csv_generator .progress-percent').html(0);
                                $this.notify(response.message, 'success');
                            } else {
                                $this.notify(response.message, 'danger');
                            }
                        }
                    });
                }
            });

            $(document).on('click', '.copy-url', function(e) {
                e.preventDefault();
                e.stopPropagation();
                var success   = true,
                    range     = document.createRange(),
                    copyText  = $('.copy-url').attr('href'),
                    selection;

                // For IE.
                if (window.clipboardData) {
                  window.clipboardData.setData("Text", copyText);
                } else {
                    // Create a temporary element off screen.
                    var tmpElem = $('<div>');
                    tmpElem.css({
                        position: "absolute",
                        left:     "-1000px",
                        top:      "-1000px",
                    });
                    // Add the input value to the temp element.
                    tmpElem.text(copyText);
                    $("body").append(tmpElem);
                    // Select temp element.
                    range.selectNodeContents(tmpElem.get(0));
                    selection = window.getSelection();
                    selection.removeAllRanges();
                    selection.addRange(range);
                    // Lets copy.
                    try { 
                        success = document.execCommand("copy", false, null);
                    } catch (e) {
                        console.log(e);
                    }
                    if (success) {
                        //alert ("The text is on the clipboard, try to paste it!");
                        // remove temp element.
                        tmpElem.remove();
                    }
                }

                $this.notify('Your url has been copied', 'success');
            });

            $(document).on('click', 'button', function (e) {
                var that = $(this);
                var th = $(this).parents('.panel').find('[data-addon_action]');
                var saveButton = th.find('button[name="save"]');
                if ($(this).hasClass('addon-button') && !$(this).hasClass('ads-no') && typeof th !== 'undefined') {
                    e.preventDefault();
                    var action = th.data('addon_action');
                    action = 'save_' + action;
                    that.addClass('animate-spinner').prop('disabled', true);
                    $.ajax({
                        url: ajaxurl,
                        data: {
                            action: 'googlecatalog_ajax', 
                            ads_action: action,
                            args: $this.serialize(th)
                        },
                        type: "POST",
                        dataType: 'json',
                        success: function (response) {
                            that.removeClass('animate-spinner').prop('disabled', false);
                            if (response.result == false) {
                                $this.notify(response.message, 'danger');
                            } else {
                                $this.notify(response.message, 'success');                                
                                $('#style-form').trigger({
                                    type : "page:load",
                                    obj  : $('#style-form')
                                });
                                /*$this.mainRequest(th);
                                if (th.data('ads_update')) {
                                    $this.mainRequest($(th.data('ads_update')));
                                }*/

                                if (typeof saveButton.data('ads_update') != 'undefined') {
                                    $('#category-list').trigger({
                                        type   : "page:load",
                                        obj    : $('#category-list'),
                                        action : 'update'
                                    });
                                }

                                if (th.data('ads_reload')) {
                                    var reload = th.data('ads_reload');
                                    if (typeof reload !== 'undefined') {
                                        location.reload();
                                    }
                                }
                            }
                        }
                    });
                }
            });
        },
        categoryChange: function() {
            var $this = this;
            $(document).on(
                'change',
                '#category_select',
                function() {
                    if ($(this).val() == 'none') {
                        $this.filter.category = '';
                    } else {
                        $this.filter.category = $(this).val();
                    }
                }
            );
        },
        currencyChange: function() {
            var $this = this;
            $(document).on(
                'change',
                '#currency_select',
                function() {
                    if ($(this).val() == 'none') {
                        $this.filter.currency = '';
                    } else {
                        $this.filter.currency = $(this).val();
                    }
                }
            );
        },
        initSelect: function(el) {
            el.find('.bootstrap-select').each(function (index, value) {
                if (typeof $(value).data('value') !== 'undefined') {
                    $(value).val($(value).data('value'));
                    //$(value).selectpicker($(value).data('value'));
                }
                if ($(value).find('option').length > 20) {
                    $(value).data('live-search', 'true');
                }
                $(value).selectpicker('refresh');
            });
            el.find('.uniform-checkbox, .uniform-radio').uniform();
        },
        disableInterface: function() {
            $('.switchery').addClass('switchery-disabled').prop('disabled', true);
            $('.btn').not('.btn-cancel-generate-csv').prop('disabled', true);
            $('.download-xml').hide();
            $('.copy-url').hide();
            $('.btn-cancel-generate-csv').removeClass('hidden-block');
        },
        enableInterface: function() {
            var $this = this;
            if (typeof $this.intervalId !== 'undefined') {
                clearInterval($this.intervalId);
                $this.intervalId = undefined;
                $this.stopProgress = true;
            }

            if (typeof $this.oldIntervalId !== 'undefined') {
                clearInterval($this.oldIntervalId);
                $this.oldIntervalId = undefined;
                $this.stopProgress = true;
            }

            $('.switchery').removeClass('switchery-disabled').prop('disabled', false);
            $('.btn').not('.btn-cancel-generate-csv').prop('disabled', false);
            $('.download-xml').show();
            $('.copy-url').show();
            $('.btn-cancel-generate-csv').addClass('hidden-block');
            $('.btn-generate-csv').removeClass('animate-spinner');
        },
        initProgressCheck: function(responseProgress) {
            var $this = this;
            console.log(process_id);
            $this.tempProgress = responseProgress;
            $this.request = false;
            $.ajax({
                url: ajaxurl,
                data: {
                    action: 'googlecatalog_ajax',
                    ads_action: 'progress_update',
                    args: ''
                },
                type: "POST",
                dataType: 'json',
                success: function (response) {
                    $this.request = true;
                    var progress = 0;
                    if (response.result == false) {
                        $('.btn-generate-csv').prop('disabled', false);
                        $this.enableInterface();
                        return false;
                    }

                    if (response.total == 0) {
                        $('.btn-generate-csv').prop('disabled', false);
                        return false;
                    }

                    if (response.finish == false
                        && response.hasOwnProperty('pid')
                    ) {
                        process_id = response.pid;
                    } 

                    if (response.finish == false
                        && response.hasOwnProperty('progress')
                    ) {
                        $this.disableInterface();
                        $('.csv_generator .progress-bar').css('width', response.progress + '%');
                        $('.csv_generator .progress-percent').html(response.progress);
                    }

                    if (response.finish == false
                        && response.hasOwnProperty('restart')
                    ) {
                        $this.restartProgress(response);
                    }

                    if (response.finish) {
                        $this.enableInterface();
                        progress = 100;
                        $('.csv_generator .progress-bar').css('width', progress + '%');
                        $('.csv_generator .progress-percent').html(progress);
                        $('.btn-generate-csv').prop('disabled', false);
                        return true;
                    }

                    $this.responseProgress = response.progress;
                    if (typeof $this.intervalId == 'undefined'
                        && !$this.stopProgress
                    ) {
                        $this.intervalId = setInterval(function() {
                            if ($this.responseProgress !== $this.tempProgress
                                || $this.request
                            ) {
                                $this.initProgressCheck($this.responseProgress);
                            }
                        }, 3000);
                    }
                },
                error: function() {
                    clearInterval($this.intervalId);
                    $this.intervalId = undefined;
                    setTimeout(function() {
                        $this.initProgressCheck();
                    },5000);
                }
            });
        },
        restartProgress: function(response) {
            var $this = this;
            $this.stopProgress = true;
            clearInterval($this.intervalId);
            $this.intervalId = undefined;
            var params = {
                currency    : $this.filter.currency,
                woocommerce : $this.filter.woocommerce
            };

            $.ajax({
                url: progress_url,
                data: {
                    action       : 'init_process',
                    args         : $.param(params),
                    categories   : $this.filter.category,
                    current_page : response.current_page
                },
                type: 'POST',
                dataType: 'json',
                success: function(response) {
                    if (response.result == false) {
                        $this.notify(response.message, 'danger');
                    } else {
                        console.log('restart progress');
                        $this.stopProgress = false;
                        $this.initProgressCheck();
                    }
                    console.log(response)
                }
            });
        },
        initXmlGeneration: function(page) {
            var $this = this;
            var params = {
                page: page,
                category: $this.filter.category,
                currency: $this.filter.currency
            };

            $this.tempPage = page;
            $this.oldRequest = false;
            $.ajax({
                url: ajaxurl,
                data: {
                    action: 'googlecatalog_ajax',
                    ads_action: 'generateXml',
                    args: $.param(params)
                },
                type: "POST",
                dataType: 'json',
                success: function (response) {
                    $this.oldRequest = true;
                    var progress = 0;
                    if (response.result == false) {
                        $('.btn-generate-csv').prop('disabled', false);
                        return false;
                    }

                    if (response.total == 0) {
                        $('.btn-generate-csv').prop('disabled', false);
                        return false;
                    }

                    if(response.finish == false) {
                        progress = response.page/response.total * 100;
                        $('.csv_generator .progress-bar').css('width', progress + '%');
                        $('.csv_generator .progress-percent').html(progress.toFixed());
                    }

                    if (response.finish) {
                        $this.enableInterface();
                        progress = 100;
                        $('.csv_generator .progress-bar').css('width', progress + '%');
                        $('.csv_generator .progress-percent').html(progress.toFixed());
                        $('.btn-generate-csv').removeClass('animate-spinner').prop('disabled', false);
                        return true;
                    }

                    $this.page = response.page;
                    if (typeof $this.oldIntervalId == 'undefined'
                        && !this.stopProgress
                    ) {
                        $this.oldIntervalId = setInterval(function() {
                            if ($this.page !== $this.tempPage
                                || $this.oldRequest
                            ) {
                                $this.initXmlGeneration($this.page);
                            }
                        }, 1000);
                    }
                },
                error: function() {
                    clearInterval($this.oldIntervalId);
                    $this.oldIntervalId = undefined;
                    setTimeout(function() {
                        $this.initXmlGeneration(params.page);
                    }, 5000);
                }
            });
        },
        init: function () {
            this.mainHandlers();
        },
        Dispatcher: {
            subscribers: [],
            /**
             *
             * @param {string} event
             * @param {function} observer
             * @param {object} context
             * @param info
             * @param {boolean} one
             *
             * @example
             * Dispatcher.on('adsGoogleExtension:name', function(e){}, this, {a1:123})
             */
            on: function (event, observer, context, info, one) {
                context = context || null;
                info = info || null;
                one = one || false;
                var handler = {
                    observer: observer,
                    context: context,
                    info: info,
                    one: one
                };

                if (this.subscribers.hasOwnProperty(event)) {
                    this.subscribers[ event ].push(handler);
                } else {
                    this.subscribers[ event ] = [handler];
                }
            },
            one: function (event, observer, context, info) {
                context = context || null;
                info = info || null;
                this.on(event, observer, context, info, true);
            },
            trigger: function (event, data) {
                console.log(this.subscribers);
                for (var ev in this.subscribers) {
                    if (ev !== event) {
                        continue;
                    }
                    if (this.subscribers.hasOwnProperty(ev)) {
                        console.log(ev);
                        this.subscribers[ ev ].forEach(function (handler, i) {
                            handler.observer.call(handler.context, data, handler.info);
                            if (handler.one) {
                                this.subscribers[ ev ].splice(i, 1);
                            }
                        });
                    }
                }
            }
        }
    };

    ADS.init();
});