<?php

namespace progress\models;

/**
 * Description of ConfigGoogle
 *
 * @author Artem Yuriev art3mk4@gmail.com Feb 15, 2019 10:43:50 AM
 */
class ConfigGoogle
{

    /**
     * $config
     */
    public static $config = ADSGOOGLECATALOG_PATH . '/progress/config/config.php';

    /**
     * $configDir
     * 
     * @var type 
     */
    public static $configDir = ADSGOOGLECATALOG_PATH . '/progress/config';

    /**
     * parseConfig
     */
    public static function parseConfig()
    {
        $config = self::$config;
    }

    /**
     * createFile
     * 
     * @param type $force
     * @return boolean
     */
    public static function createFile($force = false)
    {
        global $shortcode_tags;
        if (!$force && self::checkConfigFile()) {
            return false;
        }

        $openFile = self::checkOpenFile();
        if (!$openFile) {
            return false;
        }

        fwrite($openFile, '<?php' . PHP_EOL);
        $params = self::getParams();
        if (is_array($shortcode_tags)) {
            $shortcodeString = implode("', '", array_keys($shortcode_tags));
            $params['WP_SHORTCODES'] = "serialize(array('" . $shortcodeString . "'))";
        }

        foreach ($params as $item => $param) {
            if ($item == 'WP_SHORTCODES') {
                fwrite($openFile, 'if (!defined(\'' . $item . '\')) define(\'' . $item . '\', ' . $param . ');' . PHP_EOL);
            } else {
                fwrite($openFile, 'if (!defined(\'' . $item . '\')) define(\'' . $item . '\',\'' . $param . '\');' . PHP_EOL);
            }
        }
    }

    /**
     * checkOpenFile
     * 
     * @return boolean
     */
    public static function checkOpenFile()
    {
        $folderExists = self::checkFolderExists();
        if (!$folderExists) {
            self::createFolder();
        }

        $config = self::$config;
        $openFile = fopen($config, 'w');
        if (!$openFile) {
            return false;
        }

        return $openFile;
    }

    /**
     * checkFolderExists
     * 
     * @return boolean
     */
    public static function checkFolderExists()
    {
        if (!is_dir(self::$configDir)) {
            mkdir(self::$configDir, 0755);
        }

        if (is_writable(self::$configDir)) {
            return true;
        }

        return false;
    }

    /**
     * loadFile
     */
    public static function loadFile()
    {
        if (!self::checkConfigFile()) {
            return false;
        }

        $config = self::$config;
        include_once($config);
        return true;
    }

    /**
     * checkConfigFile
     * 
     * @return type
     */
    public static function checkConfigFile()
    {
        return file_exists(self::$config);
    }

    /**
     * getParams
     * 
     * @return type
     */
    public static function getParams()
    {
        global $wpdb;
        if (!isset($wpdb)) {
            return true;
        }

        return array(
            'DB_NAME'        => DB_NAME,
            'DB_USER'        => DB_USER,
            'DB_PASSWORD'    => DB_PASSWORD,
            'DB_HOST'        => DB_HOST,
            'DB_CHARSET'     => DB_CHARSET,
            'TABLE_PREFIX'   => $wpdb->prefix,
            'WP_CONTENT_DIR' => WP_CONTENT_DIR,
        );
    }
}