<?php

namespace progress\models;
use progress\models\pdo\MysqlPDO as MysqlPDO;

/**
 * Description of WooAttributes
 *
 * @author Artem Yuriev art3mk4@gmail.com Feb 15, 2019 1:29:39 PM
 */
class WooAttributes extends MysqlPDO
{
    /**
     *
     * @var type 
     */
    private static $instance;

    /**
     * WooAttributes construct
     */
    public function __construct()
    {
        $this->setTable('woocommerce_attribute_taxonomies');
        parent::__construct();
    }

    /**
     * instance
     * 
     * @return \progress\models\Settings
     */
    public static function instance()
    {
        if (!isset(self::$instance)) {
            self::$instance = new WooAttributes();
        }

        return self::$instance;
    }

    /**
     * getName
     * 
     * @param type $name
     */
    public function getName($name)
    {
        $parseName = trim(str_replace('attribute_pa_', '', $name));
        $sql = "SELECT attribute_label FROM " . TABLE_PREFIX . $this->table . " WHERE attribute_name = :attribute_name";
        $select = $this->prepare($sql);
        $select->bindValue(':attribute_name', $parseName);
        $select->execute();
        $result = $select->fetch(\PDO::FETCH_ASSOC);
        return $result;
    }
}